PROGRAM_NAME='Office Camera'
(***********************************************************)
(* System Type :                                           *)
(***********************************************************)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

CAM1	=	1

IO	=	17

TP	=	128


(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT


(* PICTURTEL COMMANDS *)
CPOW_ON		= "'SMbo'"
CPOW_OFF	= "'SMbi'"

CZOOM_IN 	= "'TJzi'"
CZOOM_IN_STP	= "'PJz'"
CZOOM_OUT	= "'TJzo'"
CZOOM_OUT_STP	= "'PJz'"

CPOS_UP		= "'TJtu'"
CPOS_UP_STP	= "'PJt'"
CPOS_DN		= "'TJtd'"
CPOS_DN_STP	= "'PJt'"
CPOS_LT		= "'TJpl'"
CPOS_LT_STP	= "'PJp'"
CPOS_RT		= "'TJpr'"
CPOS_RT_STP	= "'PJp'"

CFOCUS_AUTO	= "'SMfa'"
CFOCUS_IN	= "'TJfn'"
CFOCUS_IN_STP	= "'PJf'"
CFOCUS_OUT	= "'TJff'"
CFOCUS_OUT_STP	= "'PJf'"

CWB_INDOOR	= "'SMwi'"
CWB_OUTDOOR	= "'SMwo'"
CWB_AUTO	= "'SMwa'"

CIRIS_OPEN	= "'TJeu'"
CIRIS_OPEN_STP	= "'PJe'"
CIRIS_CLOSE	= "'PJd'"
CIRIS_CLOSE_STP	= "'PJe'"



cCAM1	=1


(* INFO *)
S_DATE        = 'ENTER SAVE DATE'
S_TIME        = 'ENTER SAVE TIME'

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

TRASH[255]

CAMPANPOS[4]

CAMTILTPOS[3]

CAMZOOMPOS[4]

CAMERA_BUFF[255]

(* GENERAL *)
MASTER_MSG_BUFFER[100]             (* BUFFER FOR 'MSG.LIB' *)

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE


(***********************************************************)
(*           SUBROUTINE DEFINITIONS GO BELOW               *)
(***********************************************************)
DEFINE_CALL 'CAMERA' (DEV,COMMAND[255])
{
    IF(COMMAND="'SMbi'")
    {
	SEND_STRING DEV, "$02,COMMAND,$04,$00,$00,$00" (* POWER OFF COMMAND HAS SOME EXTRA PARAMETERS*)
    }
    ELSE
    {
	SEND_STRING DEV, "$02,COMMAND,$04"
    }
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

SEND_COMMAND CAM1, 'SET BAUD 9600,O,8,1'

WAIT 2
SEND_STRING CAM1, "$02,'QGs',$04"	(* STARTUP TO INITIALIZE CAMERA, HAS TO BE DONE ANYTIME POWER ON *)
WAIT 3
SEND_STRING CAM1, "$02,'QG3',$04"
WAIT 4
SEND_STRING CAM1, "$02,'QGs',$04"
WAIT 5
SEND_STRING CAM1, "$02,'DR',$04"
WAIT 6
SEND_STRING CAM1, "$02,'SMid',$04"
WAIT 7
SEND_STRING CAM1, "$02,'SMbo',$04"
WAIT 8
SEND_STRING CAM1, "$02,'QGt',$04"
WAIT 9
SEND_STRING CAM1, "$02,'SPs0100',$04"
WAIT 10
SEND_STRING CAM1, "$02,'SMed',$04"
WAIT 11
SEND_STRING CAM1, "$02,'SMwa',$04"
WAIT 12
SEND_STRING CAM1, "$02,'SMie',$04"
WAIT 13
SEND_STRING CAM1, "$02,'SMid',$04"
WAIT 14
SEND_STRING CAM1, "$02,'SMie',$04"
WAIT 15
SEND_STRING CAM1, "$02,'QGt',$04"

(* INFO *)
CREATE_BUFFER CAM1, CAMERA_BUFF

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

(* CAMERA 3 CONTROL *)

PUSH[TP,30]
{
    CALL 'CAMERA' (CAM1,CPOW_ON)
}

PUSH[TP,31]
{
    CALL 'CAMERA' (CAM1,CPOW_OFF)
}

PUSH[TP,32]
{
    CALL 'CAMERA' (CAM1, CZOOM_IN)
}

RELEASE[TP,32]
{
    CALL 'CAMERA' (CAM1, CZOOM_IN_STP)
}

PUSH[TP,33]
{
    CALL 'CAMERA' (CAM1, CZOOM_OUT)
}

RELEASE[TP,33]
{
    CALL 'CAMERA' (CAM1, CZOOM_OUT_STP)
}

PUSH[TP,34]
{
    CALL 'CAMERA' (CAM1, CPOS_UP)
}

RELEASE[TP,34]
{
    CALL 'CAMERA' (CAM1, CPOS_UP_STP)
}

PUSH[TP,35]
{
    CALL 'CAMERA' (CAM1, CPOS_DN)
}

RELEASE[TP,35]
{
    CALL 'CAMERA' (CAM1, CPOS_DN_STP)
}

PUSH[TP,36]
{
    CALL 'CAMERA' (CAM1, CPOS_LT)
}

RELEASE[TP,36]
{
    CALL 'CAMERA' (CAM1, CPOS_LT_STP)
}

PUSH[TP,37]
{
    CALL 'CAMERA' (CAM1, CPOS_RT)
}

RELEASE[TP,37]
{
    CALL 'CAMERA' (CAM1, CPOS_RT_STP)
}
    

(* SYSTEM OFF *)
PUSH[TP,40]
{
    WAIT 30
    {
    CALL 'CAMERA' (CAM1,CPOW_OFF)
    }
}


(* SYSTEM ON *)
PUSH[TP,41]
{
    CALL 'CAMERA' (CAM1, CPOW_ON)
    WAIT 40
    {
    SEND_STRING CAM1, "$02,'QGs',$04"	(* INITIALIZE CAMERA *)
    WAIT 3
    SEND_STRING CAM1, "$02,'QG3',$04"
    WAIT 4
    SEND_STRING CAM1, "$02,'QGs',$04"
    WAIT 5
    SEND_STRING CAM1, "$02,'DR',$04"
    WAIT 6
    SEND_STRING CAM1, "$02,'SMid',$04"
    WAIT 7
    SEND_STRING CAM1, "$02,'SMbo',$04"
    WAIT 8
    SEND_STRING CAM1, "$02,'QGt',$04"
    WAIT 9
    SEND_STRING CAM1, "$02,'SPs0100',$04"
    WAIT 10
    SEND_STRING CAM1, "$02,'SMed',$04"
    WAIT 11
    SEND_STRING CAM1, "$02,'SMwa',$04"
    WAIT 12
    SEND_STRING CAM1, "$02,'SMie',$04"
    WAIT 13
    SEND_STRING CAM1, "$02,'SMid',$04"
    WAIT 14
    SEND_STRING CAM1, "$02,'SMie',$04"
    WAIT 15
    SEND_STRING CAM1, "$02,'QGt',$04"
    }
}


SELECT
{
    ACTIVE(((DAY='THU') OR (DAY='MON') OR (DAY='TUE') OR (DAY='WED') OR (DAY='FRI')) && (TIME='18:00:00')):
    {
	CALL'CAMERA'(CAM1,'QPp')	(* POLL CAMERA PAN POSITION *)
	CALL'CAMERA'(CAM1,'QPt')	(* POLL CAMERA TILT POSITION *)
	CALL'CAMERA'(CAM1,'QPz')	(* POLL CAMERA ZOOM POSITION *)

	WAIT 30
	{
	CALL 'CAMERA' (CAM1,CPOW_OFF)	(* TURN CAMERA OFF *)
	}
    }

    ACTIVE(((DAY='THU') OR (DAY='MON') OR (DAY='TUE') OR (DAY='WED') OR (DAY='FRI')) && (TIME='07:00:00')):
    {
	CALL 'CAMERA' (CAM1, CPOW_ON)	(* TURN CAMERA ON *)
	WAIT 40
	{
	SEND_STRING CAM1, "$02,'QGs',$04"	(* STARTUP SEQUENCE *)
	WAIT 3
	SEND_STRING CAM1, "$02,'QG3',$04"
	WAIT 4
	SEND_STRING CAM1, "$02,'QGs',$04"
	WAIT 5
	SEND_STRING CAM1, "$02,'DR',$04"
	WAIT 6
	SEND_STRING CAM1, "$02,'SMid',$04"
	WAIT 7
	SEND_STRING CAM1, "$02,'SMbo',$04"
	WAIT 8
	SEND_STRING CAM1, "$02,'QGt',$04"
	WAIT 9
	SEND_STRING CAM1, "$02,'SPs0100',$04"
	WAIT 10
	SEND_STRING CAM1, "$02,'SMed',$04"
	WAIT 11
	SEND_STRING CAM1, "$02,'SMwa',$04"
	WAIT 12
	SEND_STRING CAM1, "$02,'SMie',$04"
	WAIT 13
	SEND_STRING CAM1, "$02,'SMid',$04"
	WAIT 14
	SEND_STRING CAM1, "$02,'SMie',$04"
	WAIT 15
	SEND_STRING CAM1, "$02,'QGt',$04"
	}
    }
}

(* CAM 1 POSITION BUFFER *)
SELECT
{
    ACTIVE(FIND_STRING(CAMERA_BUFF,"'QPp'",1)):
    {
	TRASH=REMOVE_STRING(CAMERA_BUFF,"'QPp'",1)
	CAMPANPOS=LEFT_STRING(CAMERA_BUFF,4)
    }
    
    ACTIVE(FIND_STRING(CAMERA_BUFF,"'QPt'",1)):
    {
	TRASH=REMOVE_STRING(CAMERA_BUFF,"'QPt'",1)
	CAMTILTPOS=LEFT_STRING(CAMERA_BUFF,3)
    }
    
    ACTIVE(FIND_STRING(CAMERA_BUFF,"'QPz'",1)):
    {
	TRASH=REMOVE_STRING(CAMERA_BUFF,"'QPz'",1)
	CAMZOOMPOS=LEFT_STRING(CAMERA_BUFF,4)
    }
}

(* CODE TO EXECUTE EXACT POSITION *)
(*

    CALL'CAMERA'(CAM3,"'SPp',CAMPANPOS")
    CALL'CAMERA'(CAM3,"'SPt',CAMTILTPOS")
    CALL'CAMERA'(CAM3,"'SPz',CAMZOOMPOS")

*)

(* INFO ****************************************************)
SYSTEM_CALL 'MSG' (__FILE__,S_DATE,S_TIME,__NAME__,__VERSION__)
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

